<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">


            <el-form-item label="名称" prop="name">
              <el-input
                v-model="queryParams.name"
                placeholder="请输入名称"
                clearable
                @keyup.enter.native="handleQuery"
              />
            </el-form-item>



      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">

      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['jxc:ckchange:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="ckchangeList"  @sort-change="handleSortChange"  @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />



      <el-table-column label="名称" align="center" prop="name" sortable='custom' />
      <el-table-column label="斗轮机累计流量 (t)" align="center" prop="cumulativeFlow" sortable='custom' />

      <el-table-column label="斗轮机瞬时流量(t/h)" align="center" prop="instantaneousFlow" sortable='custom' />


    </el-table>

    <pagination

      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />


  </div>
</template>

<script>
  import { pageListCkchange, getCkchange, delCkchange, addCkchange, updateCkchange } from "@/api/jxc/ckchange";
  import {listCargo,} from "@/api/jxc/cargo";
  import { listStock } from "@/api/jxc/stock";


  export default {
    name: "Dyn",
    dicts: ['sys_inbound_outbound_type',],
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 选中名字
        names: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 仓库表格数据
        stockList: [],
        // 货物表格数据
        cargoList: [],
        // 库存变动记录表格数据
              ckchangeList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
                    custId: null,
                    changeType: null,
                    cargoId: null,
                    hsCode: null,
                    cargoName: null,
                    stockId: null,
                    stockName: null,
                    billNo: null,
                    billId: null,
                    changeNum: null,
                    beforeNum: null,
                    afterNum: null,
                    changeDate: null,
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
          cargoName: [
            { required: true, message: "货品名称不能为空", trigger: "blur" }
          ],
          stockName: [
            { required: true, message: "仓库名称不能为空", trigger: "blur" }
          ],
          changeDate: [
            { required: true, message: "变动日期不能为空", trigger: "blur" }
          ],
          billId: [
            { required: true, message: "变动单号不能为空", trigger: "blur" }
          ],
          billNo: [
            { required: true, message: "批号不能为空", trigger: "blur" }
          ],
          changeNum: [
            { required: true, message: "变动数量不能为空", trigger: "blur" }
          ],

        }
      };
    },
    created() {
      this.getList();
      this.getCargoList();
      this.getStockList();

    },
    methods: {

      setStockDetail(stockId) {
        console.log(stockId);
        this.stockList.forEach(ele => {
          if (ele.id == stockId) {
            console.log("aa:",ele.stockName);
            this.form.stockName = ele.stockName;
            this.form.stockCode = ele.stockCode;
          }
        })
      },

      getStockList() {
        let param = {};
        listStock(param).then(response => {
          this.stockList = response.data;
        }).catch(e => {
        });
      },

      //货物
      setCargoDetail(cargoId) {
        console.log(cargoId);
        this.cargoList.forEach(ele => {
          if (ele.id == cargoId) {
            console.log("aa:",ele.cargoName);
            this.form.cargoName = ele.cargoName;
            this.form.hsCode = ele.hsCode;


          }
        })
      },

      getCargoList() {
        let param = {};
        listCargo(param).then(response => {
          this.cargoList = response.data;
        }).catch(e => {
        });
      },


      /** 查询库存变动记录列表 */
      getList() {
        this.loading = true;
        pageListCkchange(this.queryParams).then(response => {
          this.ckchangeList = response.rows;
          this.total = response.total;
          this.loading = false;
        }).catch(e => {
          this.loading = false;
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
                    id: null,
                    custId: null,
                    changeType: null,
                    cargoId: null,
                    hsCode: null,
                    cargoName: null,
                    stockId: null,
                    stockName: null,
                    billNo: null,
                    billId: null,
                    changeNum: null,
                    beforeNum: null,
                    afterNum: null,
                    changeDate: null,
                    remark: null,
        };
        this.resetForm("form");
      },
      //排序
      handleSortChange(col) {
        this.$sortBy(col, this.queryParams);
        this.getList();
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id);
        this.names = selection.map(item => item.id);
        this.single = selection.length!==1;
        this.multiple = !selection.length;
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加库存变动记录";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids;
        getCkchange(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改库存变动记录";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updateCkchange(this.form).then(response => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addCkchange(this.form).then(response => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        const names = row.id || this.names;
        this.$modal.confirm('是否确认删除"' + row.hsCode+"-" + row.cargoName + '"的数据项？').then(function() {
          return delCkchange(ids);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
      },
  /** 导出按钮操作 */
  handleExport() {
    this.download('jxc/ckchange/export', {
      ...this.queryParams
    }, `库存变动记录_${new Date().getTime()}.xlsx`)
  }
  }
  };
</script>
